(*------------------------------SystemWorks.pas--------------------------
 V1.0.97 - 19.05.2002 added GetFileCharSetName
                      added GetFileFlags
                      added GetFileInfo
                      added GetFileLanguageName
                      added GetFileOS
                      added GetFileProductVersionLS
                      added GetFileProductVersionMS
                      added GetFileStrucVersion
                      added GetFileSubType
                      added GetFileType
                      added GetFileVersionLS
                      added GetFileVersionMS
                      added TDWFileFlags
                      added TDWFileInfo
                      added TDWFileOS
                      added TDWFileOSSet
                      added TDWFileSubType
                      added TDWFileType
                      added TDWFixedFileInfo
                      added TDWLangCharSet
                      added TDWVersionBlock
 V1.0.96 - 17.05.2002 current release
*------------------------------------------------------------------------*)
unit SystemWorks;

interface

uses Windows, Classes, Graphics, Messages, SysUtils, Forms, Dialogs, MMSystem,
     OSWorks;

type
   TDWBootOption = (dwboNormal,        //Normaler Systemstart
                    dwboFailSafe,      //Abgesicherter Modus
                    dwboFailSaveNet);  //Abgesicherter Modus mit Netzwerk
   TDWFileFlags  = (dwffDebug,
                    dwffInfoInferred,
                    dwffPatched,
                    dwffPrerelease,
                    dwffPrivateBuild,
                    dwffSpecialBuild);
   TDWFileInfo = packed record
                    dwSignature:        DWORD;
                    dwStrucVersion:     DWORD;
                    dwFileVersionMS:    DWORD;
                    dwFileVersionLS:    DWORD;
                    dwProductVersionMS: DWORD;
                    dwProductVersionLS: DWORD;
                    dwFileFlagsMask:    DWORD;
                    dwFileFlags:        DWORD;
                    dwFileOS:           DWORD;
                    dwFileType:         DWORD;
                    dwFileSubtype:      DWORD;
                    dwFileDateMS:       DWORD;
                    dwFileDateLS:       DWORD;
                    dwFileLanguage:     Word;
                    dwFileCharSet:      Word;
                    dwComments,
                    dwCompanyName,
                    dwFileDescription,
                    dwFileVersion,
                    dwInternalName,
                    dwLegalCopyright,
                    dwLegalTrademarks,
                    dwOriginalFilename,
                    dwPrivateBuild,
                    dwProductName,
                    dwProductVersion,
                    dwSpecialBuild:     String;
   end;
   TDWFileOS     = (dwfosDOS,
                    dwfosDOS_Windows16,
                    dwfosDOS_Windows32,
                    dwfosNT,
                    dwfosNT_Windows32,
                    dwfosWindows16,
                    dwfosWindows32,
                    dwfosOS2_16,
                    dwfosOS2_16_PM16,
                    dwfosOS2_32,
                    dwfosOS2_32_PM32,
                    dwfosPM16,
                    dwfosPM32,
                    dwfosUnknown);
   TDWFileOSSet   = Set of TDWFileOS;
   TDWFileSubType= (dwfstCOMM,
                    dwfstDisplay,
                    dwfstFontRaster,
                    dwfstFontTruetype,
                    dwfstFontVector,
                    dwfstInstallable,
                    dwfstKeyboard,
                    dwfstLanguage,
                    dwfstMouse,
                    dwfstNetwork,
                    dwfstPrinter,
                    dwfstSound,
                    dwfstSystem,
                    dwfstUnknown,
                    dwfstVersionedPrinter);
   TDWFileType   = (dwftApp,
                    dwftDLL,
                    dwftDRV,
                    dwftFont,
                    dwftStaticLib,
                    dwftUnknown,
                    dwftVXD);
   TDWFixedFileInfo = packed record
                    dwSignature:        DWORD;
                    dwStrucVersion:     DWORD;
                    dwFileVersionMS:    DWORD;
                    dwFileVersionLS:    DWORD;
                    dwProductVersionMS: DWORD;
                    dwProductVersionLS: DWORD;
                    dwFileFlagsMask:    DWORD;
                    dwFileFlags:        DWORD;
                    dwFileOS:           DWORD;
                    dwFileType:         DWORD;
                    dwFileSubtype:      DWORD;
                    dwFileDateMS:       DWORD;
                    dwFileDateLS:       DWORD;
   end;
   TDWLangCharSet = packed record
                    dwLang,
                    dwCharSet:          Word;
   end;
   TDWMenuAlignment =
                   (dwmaLeft,          //Men links unter MenuItem
                    dwmaRight);        //Men rechts unter MenuItem
   TDWMinimizedWindowArrangement =
                   (dwmwaBottomLeft,   //Unten links
                    dwmwaBottomRight,  //Unten rechts
                    dwmwaHide,         //Verborgen ( auerhalb sichtbarer Bereich )
                    dwmwaTopLeft,      //Open links
                    dwmwaTopRight);    //Oben rechts
   TDWScreenType = (dwscrtAll,           //Jeder Bildschirm
                    dwscrtDesktop,       //Alle, die ein Teil des Desktops sind
                    dwscrtMirror,        //Alle, die einen Bildschirm spiegeln
                    dwscrtRemovable,     //Auswechselbare
                    dwscrtVGA);          //VGA-kompatible
   TDWVersionBlock = packed record
                    dwVersionMajor,
                    dwVersionMinor:     Integer;
   end;
   _devicemodeA_0500 = packed record
      dmDeviceName: array [0..CCHDEVICENAME - 1] of AnsiChar;
      dmSpecVersion: Word;
      dmDriverVersion: Word;
      dmSize: Word;
      dmDriverExtra: Word;
      dmFields: DWORD;
      case Integer of // sequence rearranged (to have the biggest as last)
        1: (dmPosition: TPointL; );
        2: (dmDisplayOrientation: DWORD; );
        3: (dmDisplayFixedOutput: DWORD; );
        0: (
          dmOrientation: SHORT;
          dmPaperSize: SHORT;
          dmPaperLength: SHORT;
          dmPaperWidth: SHORT;
          dmScale: SHORT;
          dmCopies: SHORT;
          dmDefaultSource: SHORT;
          dmPrintQuality: SHORT; // );
    { end; }
      dmColor: SHORT;
      dmDuplex: SHORT;
      dmYResolution: SHORT;
      dmTTOption: SHORT;
      dmCollate: SHORT;
      dmFormName: array [0..CCHFORMNAME - 1] of AnsiChar;
      dmLogPixels: Word;
      dmBitsPerPel: DWORD;
      dmPelsWidth: DWORD;
      dmPelsHeight: DWORD;
      case Integer of
        0: (dmDisplayFlags: DWORD; );
        1: (dmNup: DWORD; // );
    { end; }
      dmDisplayFrequency: DWORD;
      dmICMMethod: DWORD;
      dmICMIntent: DWORD;
      dmMediaType: DWORD;
      dmDitherType: DWORD;
      dmReserved1: DWORD;
      dmReserved2: DWORD;
      dmPanningWidth: DWORD;
      dmPanningHeight: DWORD; ); ); // end of 'union's above
    end;

{*V1.0.97*}
function GetFileCharSetName(const FileInfo: TDWFileInfo): String;
function GetFileFlags(const FileInfo: TDWFileInfo): TDWFileFlags;
function GetFileInfo(const Filename: String): TDWFileInfo;
function GetFileLanguageName(const FileInfo: TDWFileInfo): String;
function GetFileOS(const FileInfo: TDWFileInfo): TDWFileOSSet;
function GetFileProductVersionMS(const FileInfo: TDWFileInfo): TDWVersionBlock;
function GetFileProductVersionLS(const FileInfo: TDWFileInfo): TDWVersionBlock;
function GetFileStrucVersion(const FileInfo: TDWFileInfo): TDWVersionBlock;
function GetFileSubType(const FileInfo: TDWFileInfo): TDWFileSubType;
function GetFileType(const FileInfo: TDWFileInfo): TDWFileType;
function GetFileVersionLS(const FileInfo: TDWFileInfo): TDWVersionBlock;
function GetFileVersionMS(const FileInfo: TDWFileInfo): TDWVersionBlock;

(*V1.0.96*)
function ActiveCaptionGradientColor: TColor;
function AvailablePageMemory: Int64;
function AvailablePhysicalMemory: Int64;
function AvailableVirtualMemory: Int64;
function GetBootOption: TDWBootOption;
procedure BuzzerSound(const Frequency: Word; const Delay: Cardinal);
procedure DisableCaptionCloseButton(const FormHandle: THandle);
function EmptyRecycleBin(const Confirmation, GUI, Sound: Boolean): Boolean;
procedure EnableCaptionCloseButton(const FormHandle: THandle);
function FilesInRecycleBin(var FileCount: Int64): Boolean;
function GetCapsLock: Boolean;
function GetMenuAlignment: TDWMenuAlignment;
function GetMinimizedWindowArrangement: TDWMinimizedWindowArrangement;
function GetMouseButtons: Integer;
function GetNumLock: Boolean;
function GetScrollLock: Boolean;
//procedure GetVideoModes(var ModeList: TStringList);
function HotLightColor: TColor;
function InactiveCaptionGradientColor: TColor;
function MemoryUsedPercentage: Integer;
function MenuBarColor: TColor;
function MenuHilightColor: TColor;
function MouseButtonsSwaped: Boolean;
function MouseIsPresent: Boolean;
function MouseHasWheel: Boolean;
function NetworkIsPresent: Boolean;
function ScreenCount(const ScreenType: TDWScreenType): Integer;
procedure SetCapsLock(const CapsLockOn: Boolean);
procedure SetNumLock(const NumLockOn: Boolean);
procedure SetScrollLock(const ScrollLockOn: Boolean);
function SoundCardInstalled: Boolean;
function TotalPageMemory: Int64;
function TotalPhysicalMemory: Int64;
function TotalVirtualMemory: Int64;

(*V1.0.95*)
function CPUClock: Double;
procedure MonitorOff;
procedure MonitorOn;
procedure SetSystemClock(Year, Month, Day, Hour, Minute, Second, MSecond: Integer);

implementation

function GetFileCharSetName(const FileInfo: TDWFileInfo): String;
var
   LngName: Array[0..255] of Char;
begin
   LngName:= '';
   VerLanguageName(FileInfo.dwFileCharSet, LngName, Length(LngName));
   result:= LngName;
end;

function GetFileFlags(const FileInfo: TDWFileInfo): TDWFileFlags;
begin
   case FileInfo.dwFileFlags of
   VS_FF_DEBUG:         result:= dwffDebug;
   VS_FF_INFOINFERRED:  result:= dwffInfoInferred;
   VS_FF_PATCHED:       result:= dwffPatched;
   VS_FF_PRERELEASE:    result:= dwffPrerelease;
   VS_FF_PRIVATEBUILD:  result:= dwffPrivateBuild;
   VS_FF_SPECIALBUILD:  result:= dwffSpecialBuild;
   else                 result:= dwffPrivateBuild;
   end;
end;

function GetFileInfo(const Filename: String): TDWFileInfo;
type
   pFixedFileInfo = ^TDWFixedFileInfo;
   pLangCharSet = ^TDWLangCharSet;
var
   Size, TmpSize: DWord;
   cFilename,
   Buffer: PChar;
   Ptr: Pointer;
   FixedInfo: TDWFixedFileInfo;
   PLCSet: pLangCharSet;
   Translation: String;

   function QueryCopyrightString(const EntryName, Translation: String; pInfoBuffer: Pointer): String;
   var
      Buffer: Array[0..255] of Char;
      FuncSize: UINT;
      Ptr: Pointer;
   begin
       result:= '';
       StrPCopy(Buffer, '\StringFileInfo\' + Translation + '\' + EntryName);
       if VerQueryValue(pInfoBuffer, Buffer, Ptr, FuncSize) then
         Result := StrPas(PChar(Ptr));
   end;
begin
   cFilename := StrAlloc(Length(FileName) + 1);
   StrPCopy(cFilename, FileName);
   Size:= GetFileVersionInfoSize(cFilename, TmpSize);
   if Size > 0 then
   begin
      Buffer := StrAlloc(Size);
      if GetFileVersionInfo(cFilename, TmpSize, Size, Buffer) then
      begin
         VerQueryValue(Buffer, '\', Ptr, Size);
         FixedInfo := pFixedFileInfo(Ptr)^;
         VerQueryValue(Buffer, '\VarFileInfo\Translation', Ptr, Size);
         PLCSet := pLangCharSet(Ptr);
         Translation := Format('%4.4x%4.4x',[PLCSet^.dwLang, PLCSet^.dwCharSet]);
         with result do begin
            dwComments:=         QueryCopyrightString('Comments',
                                                      Translation,
                                                      Buffer);
            dwCompanyName:=      QueryCopyrightString('CompanyName',
                                                      Translation,
                                                      Buffer);
            dwFileDescription:=  QueryCopyrightString('FileDescription',
                                                      Translation,
                                                      Buffer);
            dwFileVersion:=      QueryCopyrightString('FileVersion',
                                                      Translation,
                                                      Buffer);
            dwInternalName:=     QueryCopyrightString('InternalName',
                                                      Translation,
                                                      Buffer);
            dwLegalCopyright:=   QueryCopyrightString('LegalCopyright',
                                                      Translation,
                                                      Buffer);
            dwLegalTrademarks:=  QueryCopyrightString('LegalTrademarks',
                                                      Translation,
                                                      Buffer);
            dwOriginalFilename:= QueryCopyrightString('OriginalFilename',
                                                      Translation,
                                                      Buffer);
            dwPrivateBuild:=     QueryCopyrightString('PrivateBuild',
                                                      Translation,
                                                      Buffer);
            dwProductName:=      QueryCopyrightString('ProductName',
                                                      Translation,
                                                      Buffer);
            dwProductVersion:=   QueryCopyrightString('ProductVersion',
                                                      Translation,
                                                      Buffer);
            dwSpecialBuild:=     QueryCopyrightString('SpecialBuild',
                                                      Translation,
                                                      Buffer);
         end;
      end;
   end;
   StrDispose(cFilename);
   with result do begin
      dwSignature:=        FixedInfo.dwSignature;
      dwStrucVersion:=     FixedInfo.dwStrucVersion;
      dwFileVersionMS:=    FixedInfo.dwFileVersionMS;
      dwFileVersionLS:=    FixedInfo.dwFileVersionLS;
      dwProductVersionMS:= FixedInfo.dwProductVersionMS;
      dwProductVersionLS:= FixedInfo.dwProductVersionLS;
      dwFileFlagsMask:=    FixedInfo.dwFileFlagsMask;
      dwFileFlags:=        FixedInfo.dwFileFlags;
      dwFileOS:=           FixedInfo.dwFileOS;
      dwFileType:=         FixedInfo.dwFileType;
      dwFileSubtype:=      FixedInfo.dwFileSubtype;
      dwFileDateMS:=       FixedInfo.dwFileDateMS;
      dwFileDateLS:=       FixedInfo.dwFileDateLS;
      dwFileLanguage:=     PLCSet^.dwLang;
      dwFileCharSet:=      PLCSet^.dwCharSet;
   end;
end;

function GetFileLanguageName(const FileInfo: TDWFileInfo): String;
var
   LngName: Array[0..255] of Char;
begin
   LngName:= '';
   VerLanguageName(FileInfo.dwFileLanguage, LngName, Length(LngName));
   result:= LngName;
end;

function GetFileOS(const FileInfo: TDWFileInfo): TDWFileOSSet;
begin
   if (FileInfo.dwFileOS and VOS_DOS)>0
      then Include(result, dwfosDOS);
   if (FileInfo.dwFileOS and VOS_DOS_WINDOWS16)>0
      then Include(result, dwfosDOS_Windows16);
   if (FileInfo.dwFileOS and VOS_DOS_WINDOWS32)>0
      then Include(result, dwfosDOS_Windows32);
   if (FileInfo.dwFileOS and VOS_NT)>0
      then Include(result, dwfosNT);
   if (FileInfo.dwFileOS and VOS_NT_WINDOWS32)>0
      then Include(result, dwfosNT_Windows32);
   if (FileInfo.dwFileOS and VOS_OS216)>0
      then Include(result, dwfosOS2_16);
   if (FileInfo.dwFileOS and VOS_OS216_PM16)>0
      then Include(result, dwfosOS2_16_PM16);
   if (FileInfo.dwFileOS and VOS_OS232)>0
      then Include(result, dwfosOS2_32);
   if (FileInfo.dwFileOS and VOS_OS232_PM32)>0
      then Include(result, dwfosOS2_32_PM32);
   if (FileInfo.dwFileOS and VOS__WINDOWS16)>0
      then Include(result, dwfosWindows16);
   if (FileInfo.dwFileOS and VOS__WINDOWS32)>0
      then Include(result, dwfosWindows32);
   if (FileInfo.dwFileOS and VOS__PM16)>0
      then Include(result, dwfosPM16);
   if (FileInfo.dwFileOS and VOS__PM32)>0
      then Include(result, dwfosPM32);
   if result = [] then result:= [dwfosUnknown];
end;

function GetFileProductVersionMS(const FileInfo: TDWFileInfo): TDWVersionBlock;
begin
   result.dwVersionMajor:= (FileInfo.dwProductVersionMS and $FFFF0000) shr $10;
   result.dwVersionMinor:=  FileInfo.dwProductVersionMS and $FFFF;
end;

function GetFileProductVersionLS(const FileInfo: TDWFileInfo): TDWVersionBlock;
begin
   result.dwVersionMajor:= (FileInfo.dwProductVersionLS and $FFFF0000) shr $10;
   result.dwVersionMinor:=  FileInfo.dwProductVersionLS and $FFFF;
end;

function GetFileSubType(const FileInfo: TDWFileInfo): TDWFileSubType;
begin
   if (FileInfo.dwFileType = VFT_FONT) then begin
      case FileInfo.dwFileSubtype of
      VFT2_FONT_RASTER:   result:= dwfstFontRaster;
      VFT2_FONT_TRUETYPE: result:= dwfstFontTruetype;
      VFT2_FONT_VECTOR:   result:= dwfstFontVector;
      else                result:= dwfstUnknown;
      end;
      exit;
   end;
   case FileInfo.dwFileSubtype of
   VFT2_DRV_COMM:        result:= dwfstCOMM;
   VFT2_DRV_DISPLAY:     result:= dwfstDisplay;
   VFT2_DRV_INSTALLABLE: result:= dwfstInstallable;
   VFT2_DRV_KEYBOARD:    result:= dwfstKeyboard;
   VFT2_DRV_LANGUAGE:    result:= dwfstLanguage;
   VFT2_DRV_MOUSE:       result:= dwfstMouse;
   VFT2_DRV_NETWORK:     result:= dwfstNetwork;
   VFT2_DRV_PRINTER:     result:= dwfstPrinter;
   VFT2_DRV_SOUND:       result:= dwfstSound;
   VFT2_DRV_SYSTEM:      result:= dwfstSystem;
   VFT2_UNKNOWN:         result:= dwfstUnknown;
   else                  result:= dwfstUnknown;
   end;
end;

function GetFileType(const FileInfo: TDWFileInfo): TDWFileType;
begin
   case FileInfo.dwFileType of
   VFT_UNKNOWN:    result:= dwftUnknown;
   VFT_APP:        result:= dwftApp;
   VFT_DLL:        result:= dwftDLL;
   VFT_DRV:        result:= dwftDRV;
   VFT_FONT:       result:= dwftFont;
   VFT_VXD:        result:= dwftVXD;
   VFT_STATIC_LIB: result:= dwftStaticLib
   else            result:= dwftUnknown;
   end;
end;

function GetFileStrucVersion(const FileInfo: TDWFileInfo): TDWVersionBlock;
begin
   result.dwVersionMajor:= (FileInfo.dwStrucVersion and $FFFF0000) shr $10;
   result.dwVersionMinor:=  FileInfo.dwStrucVersion and $FFFF;
end;

function GetFileVersionLS(const FileInfo: TDWFileInfo): TDWVersionBlock;
begin
   result.dwVersionMajor:= (FileInfo.dwFileVersionLS and $FFFF0000) shr $10;
   result.dwVersionMinor:=  FileInfo.dwFileVersionLS and $FFFF;
end;

function GetFileVersionMS(const FileInfo: TDWFileInfo): TDWVersionBlock;
begin
   result.dwVersionMajor:= (FileInfo.dwFileVersionMS and $FFFF0000) shr $10;
   result.dwVersionMinor:=  FileInfo.dwFileVersionMS and $FFFF;
end;

{procedure GetVideoModes(var ModeList: TStringList);
var
  ModeNumber, j: Integer;
  MyMode: TDeviceModeA;
  Check, Need: Boolean;
  Str: string;
begin
  ModeNumber:=0;
  Check:=True;
  while(Check) do
  begin
    Check:=EnumDisplaySettings(nil, ModeNumber, MyMode);
    Str:=IntToStr(MyMode.dmPelsWidth)+'-'+IntToStr(MyMode.dmPelsHeight);
    Need:=False;
    for j:=0 to ModeList.Count-1 do
      if ModeList[j]=Str then
        Need:=True;
    if Need=False then ModeList.Add(Str);
    Inc(ModeNumber);
  end;
end;  }

procedure DisableCaptionCloseButton(const FormHandle: THandle);
var
   hMnu: THandle;
begin
   hMnu:= GetSystemMenu(FormHandle, FALSE);
   EnableMenuItem(hMnu, SC_MINIMIZE, SC_CLOSE or MF_GRAYED);
end;

procedure EnableCaptionCloseButton(const FormHandle: THandle);
var
   hMnu: THandle;
begin
   hMnu:= GetSystemMenu(FormHandle, FALSE);
   EnableMenuItem(hMnu, SC_MINIMIZE, SC_CLOSE or MF_ENABLED);
end;

function ScreenCount(const ScreenType: TDWScreenType): Integer;
const
   DISPLAY_DEVICE_ATTACHED_TO_DESKTOP = $00000001;
   DISPLAY_DEVICE_MULTI_DRIVER =        $00000002;
   DISPLAY_DEVICE_PRIMARY_DEVICE =      $00000004;
   DISPLAY_DEVICE_MIRRORING_DRIVER =    $00000008;
   DISPLAY_DEVICE_VGA_COMPATIBLE =      $00000010;
   DISPLAY_DEVICE_REMOVABLE =           $00000020;
   DISPLAY_DEVICE_MODESPRUNED =         $08000000;
   DISPLAY_DEVICE_REMOTE =              $04000000;
   DISPLAY_DEVICE_DISCONNECT =          $02000000;
var
   DeviceCount: Integer;
   DisplayDevice: TDisplayDevice;
   DeviceNum: DWord;
begin
   result:= 0;
   if (IsNT4 or IsWin95) then exit; //These OS does not support multimon
   DisplayDevice.cb:= SizeOf(DisplayDevice);
   DeviceNum:= 0;
   DeviceCount:= 1;
   while EnumDisplayDevices(NIL, DeviceNum, DisplayDevice, 0) do begin
      case ScreenType of
      dwscrtAll:
         begin
            if (DisplayDevice.StateFlags and DISPLAY_DEVICE_PRIMARY_DEVICE)>0 then
               Dec(DeviceCount);
            Inc(DeviceCount);
         end;
      dwscrtDesktop:
         begin
            if (DisplayDevice.StateFlags and DISPLAY_DEVICE_PRIMARY_DEVICE)>0 then
               Dec(DeviceCount);
            if (DisplayDevice.StateFlags and DISPLAY_DEVICE_ATTACHED_TO_DESKTOP)>0 then
               Inc(DeviceCount);
         end;
      dwscrtMirror:
         begin
            if (DisplayDevice.StateFlags and DISPLAY_DEVICE_PRIMARY_DEVICE)>0 then
               Dec(DeviceCount);
            if (DisplayDevice.StateFlags and DISPLAY_DEVICE_MIRRORING_DRIVER)>0 then
               Inc(DeviceCount);
         end;
      dwscrtRemovable:
         begin
            if (DisplayDevice.StateFlags and DISPLAY_DEVICE_PRIMARY_DEVICE)>0 then
               Dec(DeviceCount);
            if (DisplayDevice.StateFlags and DISPLAY_DEVICE_REMOVABLE)>0 then
               Inc(DeviceCount);
         end;
      dwscrtVGA:
         begin
            if (DisplayDevice.StateFlags and DISPLAY_DEVICE_PRIMARY_DEVICE)>0 then
               Dec(DeviceCount);
            if (DisplayDevice.StateFlags and DISPLAY_DEVICE_VGA_COMPATIBLE)>0 then
               Inc(DeviceCount);
         end;
      end;
      Inc(DeviceNum);
   end;
   result:= DeviceCount;
end;

function MenuHilightColor: TColor;
const
  COLOR_MENUHILIGHT = 29;
begin
   result:= clNone;
   if not IsWinXP then exit;
   result:= GetSysColor(COLOR_MENUHILIGHT);
end;

function MenuBarColor: TColor;
const
  COLOR_MENUBAR = 30;
begin
   result:= clNone;
   if not IsWinXP then exit;
   result:= GetSysColor(COLOR_MENUBAR);
end;

function HotLightColor: TColor;
const
  COLOR_HOTLIGHT = 26;
begin
   result:= clNone;
   if IsWin95 or IsNT351 or IsNT4 then exit;
   result:= GetSysColor(COLOR_HOTLIGHT);
end;


function ActiveCaptionGradientColor: TColor;
const
  COLOR_GRADIENTACTIVECAPTION = 27;
begin
   result:= clNone;
   if IsWin95 or IsNT351 or IsNT4 then exit;
   result:= GetSysColor(COLOR_GRADIENTACTIVECAPTION);
end;

function InactiveCaptionGradientColor: TColor;
const
  COLOR_GRADIENTINACTIVECAPTION = 28;
begin
   result:= clNone;
   if IsWin95 or IsNT351 or IsNT4 then exit;
   result:= GetSysColor(COLOR_GRADIENTINACTIVECAPTION);
end;

function MouseButtonsSwaped: Boolean;
begin
   result:= GetSystemMetrics(SM_SWAPBUTTON)<>0;
end;

function GetMenuAlignment: TDWMenuAlignment;
begin
   if GetSystemMetrics(SM_MENUDROPALIGNMENT)<>0 then
      result:= dwmaRight else
      result:= dwmaLeft;
end;

function GetMouseButtons: Integer;
begin
   result:= GetSystemMetrics(SM_CMOUSEBUTTONS);
end;

function GetMinimizedWindowArrangement: TDWMinimizedWindowArrangement;
begin
   case GetSystemMetrics(SM_ARRANGE) of
   ARW_BOTTOMRIGHT: result:= dwmwaBottomRight;
   ARW_HIDE:        result:= dwmwaHide;
   ARW_TOPLEFT:     result:= dwmwaTopLeft;
   ARW_TOPRIGHT:    result:= dwmwaTopRight
   else             result:= dwmwaBottomLeft;
   end;  
end;

function NetworkIsPresent: Boolean;
begin
   result:= (GetSystemMetrics(SM_NETWORK)<>0);
end;

function GetCapslock: Boolean;
var
   KS: TKeyboardState;
begin
   GetKeyboardState(KS);
   result:= (KS[VK_CAPITAL]<>0);
end;

function GetNumLock: Boolean;
var
   KS: TKeyboardState;
begin
   GetKeyboardState(KS);
   result:= (KS[VK_NUMLOCK]<>0);
end;

function GetScrollLock: Boolean;
var
   KS: TKeyboardState;
begin
   GetKeyboardState(KS);
   result:= (KS[VK_SCROLL]<>0);
end;

procedure SetCapsLock(const CapsLockOn: Boolean);
var
   KS: TKeyboardState;
begin
   GetKeyboardState(KS);
   if CapsLockOn then KS[VK_CAPITAL]:= 1 else KS[VK_CAPITAL]:= 0;
   SetKeyboardState(KS);
end;

procedure SetNumLock(const NumLockOn: Boolean);
var
   KS: TKeyboardState;
begin
   GetKeyboardState(KS);
   if NumLockOn then KS[VK_NUMLOCK]:= 1 else KS[VK_NUMLOCK]:= 0;
   SetKeyboardState(KS);
end;

procedure SetScrollLock(const ScrollLockOn: Boolean);
var
   KS: TKeyboardState;
begin
   GetKeyboardState(KS);
   if ScrollLockOn then KS[VK_SCROLL]:= 1 else KS[VK_SCROLL]:= 0;
   SetKeyboardState(KS);
end;

function GetBootOption: TDWBootOption;
begin
   case GetSystemMetrics(SM_CLEANBOOT) of
   1: result:= dwboFailSafe;
   2: result:= dwboFailSaveNet;
   else result:= dwboNormal;
   end;
end;

function MouseHasWheel: Boolean;
begin
   result:= (GetSystemMetrics(SM_MOUSEWHEELPRESENT)<>0);
end;

function MouseIsPresent: Boolean;
begin
  result:= (GetSystemMetrics(SM_MOUSEPRESENT)<>0);
end;

procedure BuzzerSound(const Frequency: Word; const Delay: Cardinal);

 function InPort(PortAddr:word): byte; assembler; stdcall;
 asm
   mov dx,PortAddr
   in al,dx
 end;

 procedure OutPort(PortAddr: word; Databyte: byte); assembler; stdcall;
 asm
   mov al,Databyte
   mov dx,PortAddr
   out dx,al
 end;

 procedure Sound(Hz : Word);
 var TmpW : Word;
 begin
   OutPort($43,182);
   TmpW :=InPort($61);
   OutPort($61,TmpW or 3);
   OutPort($42,lo(1193180 div hz));
   OutPort($42, hi(1193180 div hz));
 end;

 procedure NoSound;
 var TmpW : Word;
 begin
   OutPort($43,182);
   TmpW := InPort($61);
   OutPort($61,TmpW and 3);
 end;

begin
 if IsNTMachine then
   Windows.Beep(Frequency, Delay) else
 begin
   Sound(Frequency);
   Sleep(Delay);
   NoSound;
 end;
end;

function AvailablePageMemory: Int64;
var
   MemStat: TMemoryStatus;
begin
   MemStat.dwLength:= SizeOf(MemStat);
   GlobalMemoryStatus(MemStat);
   result:= MemStat.dwAvailPageFile;
end;

function AvailablePhysicalMemory: Int64;
var
   MemStat: TMemoryStatus;
begin
   MemStat.dwLength:= SizeOf(MemStat);
   GlobalMemoryStatus(MemStat);
   result:= MemStat.dwAvailPhys;
end;

function AvailableVirtualMemory: Int64;
var
   MemStat: TMemoryStatus;
begin
   MemStat.dwLength:= SizeOf(MemStat);
   GlobalMemoryStatus(MemStat);
   result:= MemStat.dwAvailVirtual;
end;

function MemoryUsedPercentage: Integer;
var
   MemStat: TMemoryStatus;
begin
   MemStat.dwLength:= SizeOf(MemStat);
   GlobalMemoryStatus(MemStat);
   result:= MemStat.dwMemoryLoad;
end;

function SoundCardInstalled: Boolean;
begin
   result:= WaveOutGetNumDevs > 0;
end;

function TotalPageMemory: Int64;
var
   MemStat: TMemoryStatus;
begin
   MemStat.dwLength:= SizeOf(MemStat);
   GlobalMemoryStatus(MemStat);
   result:= MemStat.dwTotalPageFile;
end;

function TotalPhysicalMemory: Int64;
var
   MemStat: TMemoryStatus;
begin
   MemStat.dwLength:= SizeOf(MemStat);
   GlobalMemoryStatus(MemStat);
   result:= MemStat.dwTotalPhys;
end;

function TotalVirtualMemory: Int64;
var
   MemStat: TMemoryStatus;
begin
   MemStat.dwLength:= SizeOf(MemStat);
   GlobalMemoryStatus(MemStat);
   result:= MemStat.dwTotalVirtual;
end;

function EmptyRecycleBin(const Confirmation, GUI, Sound: Boolean): Boolean;
const
  SHERB_NOCONFIRMATION = $00000001;
  SHERB_NOPROGRESSUI = $00000002;
  SHERB_NOSOUND = $00000004;
type
  TSHEmptyRecycleBin = function(Wnd: HWND;
                                pszRootPath: PChar;
                                dwFlags: DWORD): HRESULT;  stdcall;
var
  SHEmptyRecycleBin: TSHEmptyRecycleBin;
  LibHandle: THandle;
  Flags: DWord;
begin  { EmptyRecycleBin }
  result:= FALSE;
  Flags:= 0;
  if not Confirmation then Flags:= Flags or SHERB_NOCONFIRMATION;
  if not GUI          then Flags:= Flags or SHERB_NOPROGRESSUI;
  if not Sound        then Flags:= Flags or SHERB_NOSOUND;
  LibHandle := LoadLibrary(PChar('Shell32.dll'));
  if LibHandle <> 0 then @SHEmptyRecycleBin :=
      GetProcAddress(LibHandle, 'SHEmptyRecycleBinA')
  else
  begin
    MessageDlg('Shell32.dll konnte nicht geladen werden.', mtError, [mbOK], 0);
    Exit;
  end;
  if @SHEmptyRecycleBin <> nil then result:= (SHEmptyRecycleBin(Application.Handle, nil, Flags)=S_OK);
  FreeLibrary(LibHandle); @SHEmptyRecycleBin := nil;
end;

function FilesInRecycleBin(var FileCount: Int64): Boolean;
type
  _SHQUERYRBINFO = record
     cbSize: DWord;
     i64Sizelow, i64Sizehigh,
     i64NumItemslow, i64NumItemshigh: DWord;
  end;
  TPSHQUERYRBINFO = ^_SHQUERYRBINFO;
  TSHQueryRecycleBin = function(pszRootPath: PChar;
                                var pSHQueryRBInfo: TPSHQUERYRBINFO): HRESULT;  stdcall;
var
  SHQueryRecycleBin: TSHQueryRecycleBin;
  SHQueryRBInfo: _SHQUERYRBINFO;
  pSHQueryRBInfo : TPSHQUERYRBINFO;
  LibHandle: THandle;
begin  { EmptyRecycleBin }
  result:= FALSE;
  SHQueryRBInfo.cbSize:= SizeOf(SHQueryRBInfo);
  LibHandle := LoadLibrary(PChar('Shell32.dll'));
  if LibHandle <> 0 then @SHQueryRecycleBin :=
      GetProcAddress(LibHandle, 'SHQueryRecycleBinA')
  else
  begin
    MessageDlg('Shell32.dll konnte nicht geladen werden.', mtError, [mbOK], 0);
    Exit;
  end;
  if not Assigned(SHQueryRecycleBin) then begin
    MessageDlg('Shell32.dll konnte nicht geladen werden.', mtError, [mbOK], 0);
    Exit;
  end;

  pSHQueryRBInfo := @SHQueryRBInfo;
  SHQueryRBInfo.cbSize := sizeof(SHQueryRBInfo);
  SHQueryRBInfo.i64numitemslow := 0;
  SHQueryRBInfo.i64numitemshigh := 0;

  result:= ( SHQueryRecycleBin(PChar('c:'), pSHQueryRBInfo)=S_OK);
  filecount := SHQueryRBInfo.i64numitemslow;
  FreeLibrary(LibHandle); @SHQueryRecycleBin := nil;
end;

function CPUClock: Double;
const
 DelayTime= 500;
var
  TimerHigh,TimerLow:DWORD;
begin
  SetPriorityClass( GetCurrentProcess,REALTIME_PRIORITY_CLASS);
  SetThreadPriority( GetCurrentThread,THREAD_PRIORITY_TIME_CRITICAL);
  Sleep( 10);
  asm
    dw 310Fh
    mov TimerLow,eax
    mov TimerHigh,edx
  end;
  Sleep( DelayTime);
  asm
    dw 310Fh
    sub eax,TimerLow
    sbb edx,TimerHigh
    mov TimerLow,eax
    mov TimerHigh,edx
  end;
  Result:=TimerLow / (1000.0*DelayTime);
end;

procedure MonitorOff;
begin
   SendMessage(Application.Handle, WM_SYSCOMMAND, SC_MONITORPOWER, 0);
end;

procedure MonitorOn;
begin
   SendMessage(Application.Handle, WM_SYSCOMMAND, SC_MONITORPOWER, -1);
end;

procedure SetSystemClock(Year, Month, Day, Hour, Minute, Second, MSecond: Integer);
var
   SysTime: TSystemTime;
   DayTime: TDateTime;
begin
   DayTime:= EncodeDate(Year, Month, Day) +
             EncodeTime(Hour, Minute, Second, MSecond);
             DateTimeToSystemTime(DayTime, SysTime);
             SetLocalTime(SysTime);
end;

end.
